SystemOrganization addCategory: #'Volunti-ElectionManager-Model'!
SystemOrganization addCategory: #'Volunti-ElectionManager-View'!

VOAdministrationComponent subclass: #VOElectionManagerAdministrationComponent
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Volunti-ElectionManager-View'!

!VOElectionManagerAdministrationComponent methodsFor: 'private' stamp: 'NicolasVanderAuwera 11/14/2012 13:56'!
buildAuthorityConfigurationComponent
	^ VOElectionManagerAuthorityConfigurationComponent new! !

!VOElectionManagerAdministrationComponent methodsFor: 'accessing' stamp: 'NicolasVanderAuwera 11/18/2012 08:39'!
components
	^ super components
		at: 'Cryptographic parameters' put: VOCryptographicParametersComponent new;
		yourself! !

!VOElectionManagerAdministrationComponent methodsFor: 'initialization' stamp: 'NicolasVanderAuwera 11/18/2012 08:39'!
initialize
	super initialize.
	self session announcer
		on: RefreshContent
		do: [ :it | self call: it content ]! !

WATask subclass: #VOElectionClosureTask
	instanceVariableNames: 'election'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Volunti-ElectionManager-View'!

!VOElectionClosureTask class methodsFor: 'instance creation' stamp: 'NicolasVanderAuwera 4/9/2012 11:31'!
election: anElection
	^ self new election: anElection! !

!VOElectionClosureTask methodsFor: 'running' stamp: 'NicolasVanderAuwera 5/2/2012 09:45'!
actionTask: protocol
	protocol close: election with: VOElectionManager current configurations.
	election close! !

!VOElectionClosureTask methodsFor: 'accessing' stamp: 'NicolasVanderAuwera 4/9/2012 11:31'!
election: anElection
	election := anElection! !

!VOElectionClosureTask methodsFor: 'running' stamp: 'NicolasVanderAuwera 11/20/2012 09:28'!
go
	| protocol |
	protocol := (VOProtocol protocolWithKey: election protocol) new.
	self actionTask: protocol.
	self call: (VOLogComponent log: protocol log anchor: 'Continue')! !

VOElectionClosureTask subclass: #VOElectionOpeningTask
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Volunti-ElectionManager-View'!

!VOElectionOpeningTask methodsFor: 'running' stamp: 'NicolasVanderAuwera 5/2/2012 09:48'!
actionTask: protocol
	protocol open: election with: VOElectionManager current configurations.
	election open! !

WATask subclass: #VOElectionCreationTask
	instanceVariableNames: 'selection election'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Volunti-ElectionManager-View'!

!VOElectionCreationTask methodsFor: 'running' stamp: 'NicolasVanderAuwera 11/4/2012 08:15'!
go
	[ 
	election := (self call: selection) new.
	self
		call:
			(election asComponent
				addDecoration: (VOTWBSHeaderDecoration new headerString: 'Configure your election');
				yourself) ] whileNil: [  ].
	[ self session agent sendCreatedElection: election ]
		on: Error
		do: [ :err | 
			self twbsInformError: 'An error occured during the process'.
			self answer: nil ].
	self twbsInformSuccess: 'The election "' , election name , '" is correctly created.'.
	self answer: election! !

!VOElectionCreationTask methodsFor: 'initialization' stamp: 'NicolasVanderAuwera 11/3/2012 17:25'!
initialize
	super initialize.
	selection := WASelection new
		items: Election withAllSubclasses;
		labelBlock: [ :item | item description ];
		addDecoration: (VOTWBSHeaderDecoration new headerString: 'Choose the type of the election');
		yourself! !

WATask subclass: #VOSystemConfigurationTask
	instanceVariableNames: 'manager'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Volunti-ElectionManager-View'!

!VOSystemConfigurationTask class methodsFor: 'instance creation' stamp: 'NicolasVanderAuwera 5/5/2012 11:31'!
manager: aManager
	^ self new manager: aManager! !

!VOSystemConfigurationTask methodsFor: 'running' stamp: 'NicolasVanderAuwera 11/2/2012 12:30'!
go
	[ 
	self call: manager asComponent.
	self call: (VOSystemConfigurationCheck model: manager).
	manager isConfigured ] whileFalse! !

!VOSystemConfigurationTask methodsFor: 'accessing' stamp: 'NicolasVanderAuwera 5/5/2012 11:32'!
manager: aManager
	manager := aManager! !

VOAgentComponent subclass: #VOElectionManagerComponent
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Volunti-ElectionManager-View'!

!VOElectionManagerComponent class methodsFor: 'accessing' stamp: 'NicolasVanderAuwera 11/27/2011 13:25'!
url
	^ 'electionmanager'! !

!VOElectionManagerComponent methodsFor: 'accessing' stamp: 'NicolasVanderAuwera 12/9/2011 07:45'!
agentClass
	^ VOElectionManager! !

!VOElectionManagerComponent methodsFor: 'private' stamp: 'NicolasVanderAuwera 11/20/2012 13:07'!
buildAdministration
	^ VOElectionManagerAdministrationComponent new! !

!VOElectionManagerComponent methodsFor: 'accessing' stamp: 'NicolasVanderAuwera 11/17/2012 15:18'!
main
	^ VOElectionManagerMainComponent! !

!VOElectionManagerComponent methodsFor: 'accessing' stamp: 'NicolasVanderAuwera 11/27/2011 12:59'!
title
	^ 'Election Manager'! !

VOCertifiedAgent subclass: #VOElectionManager
	instanceVariableNames: 'manager'
	classVariableNames: 'Protocols'
	poolDictionaries: ''
	category: 'Volunti-ElectionManager-Model'!

!VOElectionManager commentStamp: 'NicolasVanderAuwera 3/1/2012 07:13' prior: 0!
I contains the different Elections.

Instance Variables:
	elections	<(Collection of: VOElection)>

Class Instance Variables:
	protocols	<ProtoObject>!

!VOElectionManager class methodsFor: 'private' stamp: 'NicolasVanderAuwera 11/20/2012 09:28'!
buidProtocols
	| dictionary |
	dictionary := Dictionary new.
	VOProtocol withAllSubclasses do: [ :class | dictionary at: class key put: class ].
	^ dictionary! !

!VOElectionManager class methodsFor: 'x509' stamp: 'NicolasVanderAuwera 5/5/2012 15:56'!
organisationUnit
	^ 'Election Manager'! !

!VOElectionManager class methodsFor: 'network' stamp: 'NicolasVanderAuwera 12/1/2011 09:23'!
port
	^ 1234! !

!VOElectionManager class methodsFor: 'network' stamp: 'NicolasVanderAuwera 11/20/2012 09:05'!
protocols
	^ Protocols ifNil: [ Protocols := self buidProtocols ]! !

!VOElectionManager methodsFor: 'private' stamp: 'NicolasVanderAuwera 11/20/2012 10:57'!
buildConfigurations
	| dictionary |
	dictionary := Dictionary new.
	VOManager allSubclasses
		do: [ :authority | dictionary at: authority key put: (VONetworkConfiguration description: authority organisationUnit key: authority key) ].
	dictionary
		at: 'voidgenerationserver'
		put: (VONetworkConfiguration description: 'ID Generation Server'  key: 'voidgenerationserver').
	dictionary
		at: 'vokeygenerationserver'
		put: (VONetworkConfiguration description: 'Key Generation Server'  key: 'vokeygenerationserver').
	dictionary
		at: 'vocertificationauthority' 
		put: (VONetworkConfiguration description: 'Certification Authority'  key: 'vocertificationauthority').
	dictionary
		at: 'vohomomorphicmanager'
		put: (VONetworkConfiguration description: 'Homomorphic Manager'  key: 'vohomomorphicmanager').
	^ VOConfigurationManager configurations: dictionary! !

!VOElectionManager methodsFor: 'removing' stamp: 'NicolasVanderAuwera 11/1/2012 14:00'!
clearConfigurations
	manager := self buildConfigurations! !

!VOElectionManager methodsFor: 'accessing' stamp: 'NicolasVanderAuwera 5/5/2012 16:15'!
configurations
	^ manager configurations! !

!VOElectionManager methodsFor: 'accessing' stamp: 'NicolasVanderAuwera 11/1/2012 14:15'!
cryptographicParameters
	cryptographicParameters ifNil: [ cryptographicParameters := CryptographicParameters new ].
	^ cryptographicParameters! !

!VOElectionManager methodsFor: 'network' stamp: 'NicolasVanderAuwera 11/20/2012 08:57'!
handle: aMessage
	super handle: aMessage.
	aMessage command = #elections
		ifTrue: [ self sendElections ].
	aMessage command = #election
		ifTrue: [ self sendElection ].
	aMessage command = #parameters
		ifFalse: [ ^ self ].
	self sendParameters! !

!VOElectionManager methodsFor: 'initialization' stamp: 'NicolasVanderAuwera 11/1/2012 14:00'!
initialize
	super initialize.
	manager := self buildConfigurations! !

!VOElectionManager methodsFor: 'testing' stamp: 'NicolasVanderAuwera 5/7/2012 10:10'!
isConfigured
	^ manager isConfigured! !

!VOElectionManager methodsFor: 'accessing' stamp: 'NicolasVanderAuwera 5/5/2012 11:28'!
manager
	^ manager! !

!VOElectionManager methodsFor: 'network' stamp: 'NicolasVanderAuwera 11/20/2012 09:12'!
sendCreatedElection: anElection
	| managersToContact |
	managersToContact := self configurations select: [ :config | anElection protocol agents includes: config key ].
	managersToContact
		do: [ :managerToContact | (VOConnection configuration: managerToContact) send: (VOCreateElectionMessage new content: anElection) ].
	self addInLog: 'The election "' , anElection name , '" was created by all authorities.'! !

!VOElectionManager methodsFor: 'network' stamp: 'NicolasVanderAuwera 11/1/2012 14:09'!
sendElection
	stream sendObject: (Election withId: stream nextLine greaseInteger)! !

!VOElectionManager methodsFor: 'network' stamp: 'NicolasVanderAuwera 11/1/2012 14:09'!
sendElections
	stream sendObject: Election database! !

!VOElectionManager methodsFor: 'network' stamp: 'NicolasVanderAuwera 11/3/2012 10:01'!
sendParameters
	"Send the cryptographic parameters and the configurations to all authorities."

	| parameters |
	parameters := Dictionary new
		at: #configurations put: self configurations;
		at: #parameters put: self cryptographicParameters deepCopy beReadonly;
		yourself.
	self configurations
		do: [ :config | (VOConnection configuration: config) send: (VOCryptographicParametersMessage new content: parameters) ]! !

WAComponent subclass: #VOSystemConfigurationCheck
	instanceVariableNames: 'model'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Volunti-ElectionManager-View'!

!VOSystemConfigurationCheck class methodsFor: 'instance creation' stamp: 'NicolasVanderAuwera 1/17/2012 11:32'!
model: aProtocol
	^ self new model: aProtocol! !

!VOSystemConfigurationCheck methodsFor: 'accessing' stamp: 'NicolasVanderAuwera 1/17/2012 11:32'!
model
	^ model! !

!VOSystemConfigurationCheck methodsFor: 'accessing' stamp: 'NicolasVanderAuwera 1/17/2012 11:32'!
model: anObject
	model := anObject! !

!VOSystemConfigurationCheck methodsFor: 'rendering' stamp: 'NicolasVanderAuwera 11/2/2012 12:39'!
renderActionsOn: html
	html div
		class: 'form-actions';
		with: [ 
					self renderCheckAllOn: html.
					html space.
					self renderCheckOn: html.
					html space.
					self renderBackOn: html.
					self renderTerminateOn: html ]! !

!VOSystemConfigurationCheck methodsFor: 'rendering' stamp: 'NicolasVanderAuwera 10/28/2012 10:44'!
renderBackOn: html
	html anchor
		class: 'btn';
		callback: [ self answer: false ];
		with: 'Back'! !

!VOSystemConfigurationCheck methodsFor: 'rendering' stamp: 'NicolasVanderAuwera 11/2/2012 12:39'!
renderCheckAllOn: html
	html anchor
		class: 'btn btn-info';
		callback: [ self model validateAllConfigurations: true ];
		with: 'Validate all configurations'! !

!VOSystemConfigurationCheck methodsFor: 'rendering' stamp: 'NicolasVanderAuwera 11/2/2012 12:39'!
renderCheckOn: html
	html anchor
		class: 'btn btn-info';
		callback: [ self model validateAllConfigurations: false ];
		with: 'Validate selected configurations'! !

!VOSystemConfigurationCheck methodsFor: 'rendering' stamp: 'NicolasVanderAuwera 11/20/2012 09:09'!
renderConfig: config on: html
	html
		paragraph: [ 
			html text: 'The ' , config description , ' is '.
			config isConfigured
				ifTrue: [ self renderCorrect: config on: html ]
				ifFalse: [ self renderError: config on: html ] ]! !

!VOSystemConfigurationCheck methodsFor: 'rendering' stamp: 'NicolasVanderAuwera 11/3/2012 07:17'!
renderContentOn: html
	self renderInformationOn: html.
	self model configurations
		keysAndValuesDo: [ :agent :config | 
			html div
				class: 'alert';
				class: 'alert-success' if: config isConfigured;
				class: 'alert-danger' if: (config notConfigured and: [ config toCheck ]);
				class: 'alert-warning' if: config toCheck not;
				with: [ self renderConfig: config on: html ] ].
	self renderActionsOn: html! !

!VOSystemConfigurationCheck methodsFor: 'rendering' stamp: 'NicolasVanderAuwera 11/20/2012 09:10'!
renderCorrect: config on: html
	html
		text: 'correctly configured.';
		break;
		text: 'It is listenning on port ';
		strong: config port! !

!VOSystemConfigurationCheck methodsFor: 'rendering' stamp: 'NicolasVanderAuwera 11/20/2012 09:10'!
renderError: config on: html
	html
		text: 'misconfigured.';
		break;
		strong: ' Message: ';
		text: config errorMsg! !

!VOSystemConfigurationCheck methodsFor: 'rendering' stamp: 'NicolasVanderAuwera 10/28/2012 10:39'!
renderInformationOn: html
	self model isConfigured
		ifFalse: [ 
			html div
				class: 'alert alert-info';
				with: [ 
							html
								paragraph:
									'All agents must be correctly configured before the election is created. Click on the back anchor in the bottom of the page to reconfigure agents.' ] ].
	html horizontalRule! !

!VOSystemConfigurationCheck methodsFor: 'rendering' stamp: 'NicolasVanderAuwera 11/20/2012 08:56'!
renderTerminateOn: html
	self model isConfigured
		ifFalse: [ ^ self ].
	html space.
	html anchor
		class: 'btn btn-success';
		callback: [ self terminate ];
		with: 'Terminate'! !

!VOSystemConfigurationCheck methodsFor: 'actions' stamp: 'NicolasVanderAuwera 11/3/2012 08:08'!
terminate
	self session agent sendParameters.
	self answer! !

WAComponent subclass: #VOSystemInitializationView
	instanceVariableNames: 'protocol'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Volunti-ElectionManager-View'!

!VOSystemInitializationView class methodsFor: 'initialization' stamp: 'NicolasVanderAuwera 11/20/2012 09:16'!
initializeSystemWith: aProtocol
	^ self new protocol: aProtocol! !

!VOSystemInitializationView methodsFor: 'accessing' stamp: 'NicolasVanderAuwera 4/9/2012 10:47'!
protocol: aProtocol
	protocol := aProtocol! !

!VOSystemInitializationView methodsFor: 'rendering' stamp: 'NicolasVanderAuwera 4/9/2012 10:45'!
renderContentOn: html
	self renderLogOn: html! !

!VOSystemInitializationView methodsFor: 'rendering' stamp: 'NicolasVanderAuwera 4/9/2012 10:47'!
renderLogOn: html
	html textArea
		readonly: true;
		value: protocol log! !

WAComponent subclass: #VOUserEditor
	instanceVariableNames: 'report rows'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Volunti-ElectionManager-View'!

!VOUserEditor methodsFor: 'actions' stamp: 'NicolasVanderAuwera 11/20/2012 08:56'!
addUser
	self session announcer
		announce:
			(RefreshContent
				content:
					(VOSystemUser new asComponent
						onAnswer: [ :anUser | 
									anUser
										ifNotNil: [ :arg | 
											rows add: anUser.
											self refresh ] ];
						yourself))! !

!VOUserEditor methodsFor: 'private' stamp: 'NicolasVanderAuwera 11/2/2012 10:55'!
buildReport
	^ (TWBSMagritteReport rows: rows description: VOSystemUser new magritteDescription)
		addColumn:
				(MACommandColumn new
						addCommandOn: self selector: #editUser: text: 'edit';
						addCommandOn: self selector: #removeUser: text: 'remove';
						yourself);
		yourself! !

!VOUserEditor methodsFor: 'hooks' stamp: 'NicolasVanderAuwera 11/1/2012 12:15'!
children
	^ super children copyWith: self report! !

!VOUserEditor methodsFor: 'actions' stamp: 'NicolasVanderAuwera 11/1/2012 17:23'!
editUser: anUser
	self session announcer announce: (RefreshContent content: anUser asComponent)! !

!VOUserEditor methodsFor: 'initialization' stamp: 'NicolasVanderAuwera 11/2/2012 10:55'!
initialize
	super initialize.
	rows := VOSystemUser database! !

!VOUserEditor methodsFor: 'actions' stamp: 'NicolasVanderAuwera 11/1/2012 12:45'!
refresh
	self report rows: rows! !

!VOUserEditor methodsFor: 'removing' stamp: 'NicolasVanderAuwera 11/1/2012 12:48'!
removeUser: anUser
	rows remove: anUser.
	self refresh! !

!VOUserEditor methodsFor: 'rendering' stamp: 'NicolasVanderAuwera 11/1/2012 17:26'!
renderButtonOn: html
	html div
		class: 'form-actions form-horizontal';
		with: [ 
					html submitButton
						class: 'btn btn-primary';
						callback: [ self addUser ];
						with: 'Add' ]! !

!VOUserEditor methodsFor: 'rendering' stamp: 'NicolasVanderAuwera 11/1/2012 12:20'!
renderContentOn: html
	html form class: 'magritte form-horizontal'; with: [ 
		self renderReportOn: html.
		self renderButtonOn: html ]! !

!VOUserEditor methodsFor: 'rendering' stamp: 'NicolasVanderAuwera 11/1/2012 12:19'!
renderReportOn: html
	html render: self report! !

!VOUserEditor methodsFor: 'accessing' stamp: 'NicolasVanderAuwera 11/1/2012 11:53'!
report
	^ report ifNil: [ report := self buildReport ]! !

VOManagerMainComponent subclass: #VOElectionManagerMainComponent
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Volunti-ElectionManager-View'!

!VOElectionManagerMainComponent methodsFor: 'adding' stamp: 'NicolasVanderAuwera 11/3/2012 13:36'!
addElection
	| election |
	election := self call: VOElectionCreationTask new.
	election ifNotNil: [ :arg | Election add: election ]! !

!VOElectionManagerMainComponent methodsFor: 'private' stamp: 'NicolasVanderAuwera 11/18/2012 08:52'!
buildElectionsListComponent
	^ VOElectionManagerElectionsListComponent elections: Election database! !

!VOElectionManagerMainComponent methodsFor: 'rendering' stamp: 'NicolasVanderAuwera 11/3/2012 13:35'!
createElectionTask
	"	self agent configurationCheck.
	self agent isConfigured
		ifTrue: [ self agent addElection: (self call: VOElectionCreationTask new) ]
		ifFalse: [ self inform: 'Some agents are misconfigured. Please verify your configuration befor creating a new election.' ]"

	"Election add: (self call: Election new asComponent)"
	Election add: (self call: VOElectionCreationTask new)! !

!VOElectionManagerMainComponent methodsFor: 'rendering' stamp: 'NicolasVanderAuwera 11/17/2012 15:06'!
renderConfigurationOn: html
	html
		div: [ 
			html
				paragraph: [ 
					html text: 'You must configure the system before creating elections. Click '.
					self renderConfigureAnchorText: 'here' On: html.
					html text: ' to configure the system.' ] ]! !

!VOElectionManagerMainComponent methodsFor: 'rendering' stamp: 'NicolasVanderAuwera 11/17/2012 15:06'!
renderConfigureAnchorText: text On: html
	html anchor
		class: 'btn btn-info';
		callback: [ self call: (VOSystemConfigurationTask manager: self agent manager) ];
		with: text! !

!VOElectionManagerMainComponent methodsFor: 'rendering' stamp: 'NicolasVanderAuwera 11/20/2012 08:55'!
renderCreateOn: html
	html div
		class: 'form-actions form-horizontal';
		with: [ 
					html anchor
						class: 'btn btn-success';
						callback: [ self addElection ];
						with: 'New election' ]! !

!VOElectionManagerMainComponent methodsFor: 'rendering' stamp: 'NicolasVanderAuwera 11/17/2012 15:07'!
renderMainContentOn: html
	super renderMainContentOn: html.
	self session isAdmin
		ifTrue: [ 
			self agent isConfigured
				ifFalse: [ self renderConfigurationOn: html ] ]! !

!VOElectionManagerMainComponent methodsFor: 'rendering' stamp: 'NicolasVanderAuwera 11/20/2012 08:59'!
renderRestrictedContentOn: html
	self session isAgentConfigured
		ifFalse: [ ^ self ].
	super renderRestrictedContentOn: html.
	self renderCreateOn: html! !

VOElectionsListComponent subclass: #VOElectionManagerElectionsListComponent
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Volunti-ElectionManager-View'!

!VOElectionManagerElectionsListComponent methodsFor: 'rendering' stamp: 'NicolasVanderAuwera 10/27/2012 15:14'!
renderClose: election on: html
	html anchor
		class: 'btn btn-error';
		callback: [ self call: (VOElectionClosureTask election: election) ];
		with: 'Close'! !

!VOElectionManagerElectionsListComponent methodsFor: 'rendering' stamp: 'NicolasVanderAuwera 11/20/2012 09:08'!
renderDateOf: election on: html
	election startDate isNil
		ifTrue: [ html tableData: 'None' ]
		ifFalse: [ html tableData: election startDate asDate ].
	election endDate isNil
		ifTrue: [ html tableData: 'None' ]
		ifFalse: [ html tableData: election endDate asDate ]! !

!VOElectionManagerElectionsListComponent methodsFor: 'rendering' stamp: 'NicolasVanderAuwera 11/17/2012 13:13'!
renderDetailsOf: election on: html
	html anchor
		callback: [ self call: (VOElectionComponent with: election) ];
		with: 'View Details'! !

!VOElectionManagerElectionsListComponent methodsFor: 'rendering' stamp: 'NicolasVanderAuwera 11/20/2012 09:08'!
renderMoreData: election on: html
	html tableData: [ self renderDetailsOf: election on: html ].
	html tableData
		class: 'opened' if: election opened;
		with: [ 
					election opened
						ifTrue: [ self renderClose: election on: html ]
						ifFalse: [ self renderOpen: election on: html ] ].
	self renderDateOf: election on: html! !

!VOElectionManagerElectionsListComponent methodsFor: 'rendering' stamp: 'NicolasVanderAuwera 4/9/2012 14:36'!
renderMoreDataHeadingOn: html
	html tableHeading: 'Details'.
	html tableHeading: 'Action'.
	html tableHeading: 'Start Date'.
	html tableHeading: 'End Date'! !

!VOElectionManagerElectionsListComponent methodsFor: 'rendering' stamp: 'NicolasVanderAuwera 10/27/2012 15:13'!
renderOpen: election on: html
	html anchor
		class: 'btn btn-success';
		callback: [ self call: (VOElectionOpeningTask election: election) ];
		with: 'Open'! !

GRObject subclass: #VOProtocol
	instanceVariableNames: 'agents'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Volunti-ElectionManager-Model'!

VOProtocol subclass: #VOAnonymousProtocol
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Volunti-ElectionManager-Model'!

!VOAnonymousProtocol class methodsFor: 'accessing' stamp: 'NicolasVanderAuwera 1/27/2012 14:23'!
description
	^ 'Provides the following properties: anonymity'! !

!VOAnonymousProtocol class methodsFor: 'accessing' stamp: 'NicolasVanderAuwera 1/27/2012 11:01'!
key
	^ 'anonymous'! !

!VOAnonymousProtocol methodsFor: 'private' stamp: 'NicolasVanderAuwera 11/20/2012 09:15'!
buildAgents
	^ super buildAgents , (Array with: #voanonymousmanager with: #voregistrationofficeManager with: #vopublicboardmanager)! !

!VOAnonymousProtocol methodsFor: 'testing' stamp: 'NicolasVanderAuwera 11/4/2012 08:08'!
isAnonymous
	^ true! !

!VOAnonymousProtocol methodsFor: 'testing' stamp: 'NicolasVanderAuwera 5/5/2012 08:47'!
isSimple
	^ false! !

VOAnonymousProtocol subclass: #VOMentalBoothProtocol
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Volunti-ElectionManager-Model'!

VOMentalBoothProtocol subclass: #VOAlternativeMBProtocol
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Volunti-ElectionManager-Model'!

!VOAlternativeMBProtocol class methodsFor: 'accessing' stamp: 'NicolasVanderAuwera 2/16/2012 09:00'!
description
	^ 'The interface displays m values that the voter has to bind to candidates, including the voter''s secret key'! !

!VOAlternativeMBProtocol class methodsFor: 'accessing' stamp: 'NicolasVanderAuwera 2/16/2012 08:58'!
key
	^ 'alternative'! !

!VOAlternativeMBProtocol methodsFor: 'accessing' stamp: 'NicolasVanderAuwera 5/8/2012 11:01'!
ballot
	^ VOMBAlternativeBallot! !

!VOMentalBoothProtocol class methodsFor: 'accessing' stamp: 'NicolasVanderAuwera 1/27/2012 14:24'!
description
	^ 'Provides the following properties: anonymity, coercion-resistance, receipt-freeness'! !

!VOMentalBoothProtocol class methodsFor: 'accessing' stamp: 'NicolasVanderAuwera 1/27/2012 11:01'!
key
	^ 'mentalbooth'! !

!VOMentalBoothProtocol methodsFor: 'accessing' stamp: 'NicolasVanderAuwera 2/21/2012 10:06'!
ballot
	^ VOMBBallot! !

!VOMentalBoothProtocol methodsFor: 'private' stamp: 'NicolasVanderAuwera 11/20/2012 09:15'!
buildAgents
	^ super buildAgents
		,
			(Array
				with: #vomentalboothmanager
				with: #vompdvsmanager
				with: #vowitnessmanager
				with: #vohomomorphicmanager)! !

!VOMentalBoothProtocol methodsFor: 'testing' stamp: 'NicolasVanderAuwera 11/4/2012 08:08'!
isAnonymous
	^ false! !

!VOMentalBoothProtocol methodsFor: 'testing' stamp: 'NicolasVanderAuwera 11/4/2012 08:08'!
isMentalBooth
	^ true! !

!VOProtocol class methodsFor: 'accessing' stamp: 'NicolasVanderAuwera 2/16/2012 08:53'!
description
	^ 'No property is supported.'! !

!VOProtocol class methodsFor: 'accessing' stamp: 'NicolasVanderAuwera 2/16/2012 08:52'!
key
	^ 'simple'! !

!VOProtocol class methodsFor: 'searching' stamp: 'NicolasVanderAuwera 4/9/2012 11:44'!
protocolWithKey: aSymbol
	^ self withAllSubclasses detect: [ :protocolClass | protocolClass key = aSymbol ]! !

!VOProtocol class methodsFor: 'accessing' stamp: 'NicolasVanderAuwera 1/27/2012 14:22'!
title
	^ self key capitalized! !

!VOProtocol methodsFor: 'accessing' stamp: 'NicolasVanderAuwera 1/17/2012 08:50'!
agents
	^ agents! !

!VOProtocol methodsFor: 'accessing' stamp: 'NicolasVanderAuwera 2/16/2012 08:25'!
ballot
	^ nil! !

!VOProtocol methodsFor: 'private' stamp: 'NicolasVanderAuwera 11/20/2012 09:14'!
buildAgents
	^ Array with: #vopollingofficemanager! !

!VOProtocol methodsFor: 'initialization' stamp: 'NicolasVanderAuwera 11/20/2012 09:14'!
initialize
	super initialize.
	agents := self buildAgents! !

!VOProtocol methodsFor: 'testing' stamp: 'NicolasVanderAuwera 11/4/2012 08:07'!
isAlternative
	^ false! !

!VOProtocol methodsFor: 'testing' stamp: 'NicolasVanderAuwera 11/4/2012 08:07'!
isAnonymous
	^ false! !

!VOProtocol methodsFor: 'testing' stamp: 'NicolasVanderAuwera 11/4/2012 08:07'!
isMentalBooth
	^ false! !

!VOProtocol methodsFor: 'testing' stamp: 'NicolasVanderAuwera 5/5/2012 08:47'!
isSimple
	^ true! !

VOAuthorityConfigurationComponent subclass: #VOElectionManagerAuthorityConfigurationComponent
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Volunti-ElectionManager-View'!

!VOElectionManagerAuthorityConfigurationComponent methodsFor: 'rendering' stamp: 'NicolasVanderAuwera 11/14/2012 13:56'!
renderContentOn: html
	super renderContentOn: html.
	html anchor
		class: 'btn btn-info';
		callback: [ self configureSystem ];
		with: 'Configure system'! !
